/*
 * Assignment 1, part3. 
 * Anupam Prakash 
 * SID:20204004
 */


-- 3. Splitting into sessions.


-- Register user defined functions for use. 
REGISTER ./myudfs.jar; 

-- Load the excite log file into the raw bag as an array of records.
-- Input: (user,time,query) 
raw = LOAD 'excite-small.log' USING PigStorage('\t') AS (user: chararray, time: long, query: chararray);

-- Filter raw to extract non empty queries. 
nonempty = FILTER raw BY SIZE(query)>0; 

-- Generate relation (user, bag of queries). 
users = GROUP nonempty BY user;

-- User defined SESSIONS function takes bag of user queries ordered by time as input. 
-- Outputs number of sessions. 
 
-- Tuples must be fed to the SESSIONS in sorted order. 
-- Ref: Chapter 6 of Programming Pig uses nested foreach to accomplish this. 

session = FOREACH users {
	sorted= ORDER nonempty by time; 
	GENERATE group as user, myudfs.SESSIONS(sorted) as sessions; 
};
-- session is a relation of form (user, num sessions). 

-- Generate relation (number of sessions), drop user information. 
svec = FOREACH  session GENERATE $1 as num; 

sgrp = GROUP svec ALL; 

-- Compute aggregate statistics on the sessions vector. 
-- Average and max are available, user defined STD function computes the standard deviation. 

savg = FOREACH sgrp GENERATE MAX($1) as max, AVG($1) as mean, myudfs.STD($1) as stddev; 
dump savg; 


-- Output: Max, Average, Std Deviation: (7,1.279258400926999,0.6566620271024322)

